module.exports = askChatWithPrompt;

function askChat(str, app) {
	const prompt = encodeURI(str);

	const chatViewEl = app.workspace.getLeavesOfType("surfing-view").find((item)=>{ return /chat\.openai\.com/.test(item?.view?.currentUrl)}).view.webviewEl;
	chatViewEl.executeJavaScript(`
		var htmlElement = document.querySelector("textarea");
		htmlElement.value = decodeURI("${ prompt }");
		htmlElement.parentElement.childNodes[1].click();
	`, true).then((result) => {
		console.log(result);
	});
}

async function askChatWithPrompt(params) {
	const {app, Notice} = params;
	const view = app.workspace.activeLeaf.view;
	if(!view) {
		new Notice("Please focus on view");
	}

	let selection = "";
	// Change prompt here: 
	const customPrompt = "다음에 대해 정리해주세요：";
	if(view.getViewType() === "markdown") {
		selection = view.editor.getSelection();
		askChat(customPrompt + selection , app);
	} else if (view.getViewType() === "surfing-view" || view.getViewType() === "surfing-file-view") {
		view.webviewEl.executeJavaScript(`
			document.getSelection().toString();
		`,true).then((result)=> {
			selection = result;
			askChat(customPrompt + selection , app);
		});
	} else {
		new Notice("Wrong View");
	}
}